
# Struct Nodo que contiene un valor (:value) , su siguiente nodo enlazado o nil (:next) y su previo nodo enlazado o nil (:prev)
Nodo = Struct.new(:value, :next, :prev)


# Clase Lista que representa una lista doblemente enlazada con un inicio y un fin.
class Lista
    include Enumerable 
    attr_reader :inicio, :final
    
    # Método que recorre la lista y devuelve un vector con los valores de esta, necesario para los métodos de Enumerable (sort,min,max)
    def each
        node = @inicio
        while(node!=nil)
            yield node.value
            node = node.next
        end
    end
    def to_s
        
        output = ""
        node = @inicio
        
        while(node!=nil)
            output << "#{node.value}"
            node = node.next
        end
        
        output
        
    end
    # Constructor de la clase
    def initialize
        @inicio = nil
        @final = nil
    end

    # Método que obtiene el inicio de la lista
    def get_inicio
        @inicio
    end
    
    # Método que obtiene el inicio de la lista
    def get_final
        @final
    end
    
    #Método que comprueba si la lista está vacía
    def empty
        if(@inicio == nil)
            true
        elsif
            false
        end
    end
    
    # Método que inserta un valor en la lista (por el final)
    def insert(x)
        node = Nodo.new(x,nil,nil)
        if(empty)
            @inicio = node
            @final = node
        elsif
            @final.next = node
            node.prev = @final
            @final = node
        end
        true
    end
    
    # Método que extrae un valor de la lista (por el inicio)
    def extract
        if(empty)
            nil
        elsif
            node = @inicio
            @inicio = node.next
            if(!empty)
                @inicio.prev = nil
            end 
            node.next = nil
            node.value
        end
    end
    
end